create table bw_adminGroupMembers (groupid integer not null, memberid integer not null, member_is_group char(1) not null, primary key (groupid, memberid, member_is_group))
create table bw_adminGroups (userid integer generated by default as identity (start with 1), bwseq integer not null, account longvarchar, description longvarchar, groupOwner integer not null, ownerid integer not null, primary key (userid))
create table bw_alarm_attendees (alarmid integer not null, attendeeid integer not null, primary key (alarmid, attendeeid))
create table bw_alarms (alarmid integer generated by default as identity (start with 1), bwseq integer not null, alarm_type integer, ownerid integer not null, publick char(1) not null, trigger_rfctime longvarchar, trigger_start char(1) not null, duration longvarchar, repetitions integer, attach longvarchar, description longvarchar, summary longvarchar, trigger_time bigint, previous_trigger bigint, repeat_count integer, expired char(1) not null, eventid integer, primary key (alarmid))
create table bw_ann_alarms (eventid integer not null, alarmid integer not null, primary key (eventid, alarmid))
create table bw_anneventrecipients (eventid integer not null, recipient varchar(255) not null, primary key (eventid, recipient))
create table bw_attendees (attendeeid integer generated by default as identity (start with 1), cn longvarchar, cutype longvarchar, delegated_from longvarchar, delegated_to longvarchar, dir longvarchar, lang longvarchar, member longvarchar, rsvp char(1), role longvarchar, partstat longvarchar, sent_by longvarchar, attendee_uri longvarchar, rfcsequence integer, dtstamp varchar(16), primary key (attendeeid))
create table bw_auth (userid integer not null, bwseq integer not null, usertype integer, primary key (userid))
create table bw_authprefCalendars (userid integer not null, calendarid integer not null, primary key (userid, calendarid))
create table bw_authprefCategories (userid integer not null, categoryid integer not null, primary key (userid, categoryid))
create table bw_authprefContacts (userid integer not null, contactid integer not null, primary key (userid, contactid))
create table bw_authprefLocations (userid integer not null, locationid integer not null, primary key (userid, locationid))
create table bw_authprefs (userid integer not null, bwseq integer not null, autoaddCategories char(1) not null, autoaddLocations char(1) not null, autoaddContacts char(1) not null, autoaddCalendars char(1) not null, primary key (userid))
create table bw_calendar_categories (calendarid integer not null, categoryid integer not null, primary key (calendarid, categoryid))
create table bw_calendars (id integer generated by default as identity (start with 1), bwseq integer not null, creatorid integer not null, ownerid integer not null, bwaccess longvarchar, publick char(1) not null, calname longvarchar not null, bwpath varchar(1000) not null, summary longvarchar, description longvarchar, mail_list_id varchar(200), calendar_collection char(1) not null, parent integer, caltype integer not null, bw_lastmod varchar(16) not null, bwsequence integer, bw_created varchar(16) not null, primary key (id))
create table bw_calsuites (csid integer generated by default as identity (start with 1), bwseq integer not null, creatorid integer not null, ownerid integer not null, bwaccess longvarchar, publick char(1) not null, csname varchar(255) not null, groupid integer not null, csrootcal integer not null, primary key (csid), unique (csname))
create table bw_categories (categoryid integer generated by default as identity (start with 1), bwseq integer not null, creatorid integer not null, ownerid integer not null, bwaccess longvarchar, publick char(1) not null, bw_catwdid integer not null, bw_catdescid integer, primary key (categoryid), unique (bw_catdescid), unique (bw_catwdid))
create table bw_contacts (entityid integer generated by default as identity (start with 1), bwseq integer not null, creatorid integer not null, ownerid integer not null, bwaccess longvarchar, publick char(1) not null, bw_uid varchar(50) not null, bw_connameid integer not null, bw_phone varchar(255), bw_email varchar(255), bw_link varchar(255), primary key (entityid), unique (bw_connameid))
create table bw_entity_alarms (eventid integer not null, alarmid integer not null, primary key (eventid, alarmid))
create table bw_event_annotation_attendees (attendeeid integer not null, elt integer not null, primary key (attendeeid, elt))
create table bw_event_annotation_categories (eventid integer not null, categoryid integer not null, primary key (eventid, categoryid))
create table bw_event_annotationexdates (eventid integer not null, ex_date_type char(1) not null, ex_tzid varchar(255), ex_dtval varchar(16) not null, ex_date varchar(16) not null, primary key (eventid, ex_date_type, ex_dtval, ex_date))
create table bw_event_annotationrdates (eventid integer not null, r_date_type char(1) not null, r_tzid varchar(255), r_dtval varchar(16) not null, r_date varchar(16) not null, primary key (eventid, r_date_type, r_dtval, r_date))
create table bw_event_annotationrrules (eventid integer not null, rrule varchar(255))
create table bw_event_annotations (eventid integer generated by default as identity (start with 1), bwseq integer not null, bw_entity_type integer, creatorid integer, ownerid integer, bwaccess longvarchar, publick char(1), start_date_type char(1), start_tzid varchar(255), start_dtval varchar(16), start_date varchar(16), bw_start_floating char(1), end_date_type char(1), end_tzid varchar(255), end_dtval varchar(16), end_date varchar(16), bw_end_floating char(1), duration varchar(255), end_type char(1), bw_nostart char(1), deleted char(1), bw_class varchar(250), bwlink varchar(255), bw_geolatitude float, bw_geolongitude float, status varchar(255), cost varchar(255), calendarid integer, dtstamp varchar(255), lastmod varchar(16), created varchar(16), priority integer, locationid integer, eventname longvarchar, bw_uid varchar(500), rfcsequence integer, transparency longvarchar, percent_complete integer, completed varchar(16), recurring char(1), recurrence_id varchar(255), latest_date varchar(255), expanded char(1), schedule_method integer, originator varchar(255), organizerid integer, bw_reltype varchar(100), bw_reltoval varchar(500), schedule_state integer, targetid integer, masterid integer, bw_override char(1) not null, bw_alarms_empty char(1), bw_attendees_empty char(1), bw_categories_empty char(1), bw_comments_empty char(1), bw_contacts_empty char(1), bw_descriptions_empty char(1), bw_exdates_empty char(1), bw_exrules_empty char(1), bw_rdates_empty char(1), bw_recipients_empty char(1), bw_request_statuses_empty char(1), bw_resources_empty char(1), bw_rrules_empty char(1), bw_summaries_empty char(1), primary key (eventid), unique (organizerid))
create table bw_event_attendees (eventid integer not null, attendeeid integer not null, primary key (eventid, attendeeid))
create table bw_event_categories (eventid integer not null, categoryid integer not null, primary key (eventid, categoryid))
create table bw_eventanncomments (bw_eventid integer not null, bw_strid integer not null, primary key (bw_eventid, bw_strid), unique (bw_strid))
create table bw_eventanncontacts (eventid integer not null, contactid integer not null, primary key (eventid, contactid))
create table bw_eventanndescriptions (bw_eventid integer not null, bw_strid integer not null, primary key (bw_eventid, bw_strid), unique (bw_strid))
create table bw_eventannresources (bw_eventid integer not null, bw_strid integer not null, primary key (bw_eventid, bw_strid), unique (bw_strid))
create table bw_eventannsummaries (bw_eventid integer not null, bw_strid integer not null, primary key (bw_eventid, bw_strid), unique (bw_strid))
create table bw_eventcomments (bw_eventid integer not null, bw_strid integer not null, primary key (bw_eventid, bw_strid), unique (bw_strid))
create table bw_eventcontacts (eventid integer not null, contactid integer not null, primary key (eventid, contactid))
create table bw_eventdescriptions (bw_eventid integer not null, bw_strid integer not null, primary key (bw_eventid, bw_strid), unique (bw_strid))
create table bw_eventexdates (eventid integer not null, ex_date_type char(1) not null, ex_tzid varchar(255), ex_dtval varchar(16) not null, ex_date varchar(16) not null, primary key (eventid, ex_date_type, ex_dtval, ex_date))
create table bw_eventexrules (eventid integer not null, exrule varchar(255) not null, primary key (eventid, exrule))
create table bw_eventrdates (eventid integer not null, r_date_type char(1) not null, r_tzid varchar(255), r_dtval varchar(16) not null, r_date varchar(16) not null, primary key (eventid, r_date_type, r_dtval, r_date))
create table bw_eventrecipients (eventid integer not null, recipient varchar(255) not null, primary key (eventid, recipient))
create table bw_eventresources (bw_eventid integer not null, bw_strid integer not null, primary key (bw_eventid, bw_strid), unique (bw_strid))
create table bw_eventrrules (eventid integer not null, rrule varchar(255) not null, primary key (eventid, rrule))
create table bw_events (eventid integer generated by default as identity (start with 1), bwseq integer not null, bw_entity_type integer, creatorid integer not null, ownerid integer not null, bwaccess longvarchar, publick char(1) not null, start_date_type char(1) not null, start_tzid varchar(255), start_dtval varchar(16) not null, start_date varchar(16) not null, bw_start_floating char(1), end_date_type char(1), end_tzid varchar(255), end_dtval varchar(16), end_date varchar(16), bw_end_floating char(1), duration varchar(255), end_type char(1) not null, bw_nostart char(1) not null, deleted char(1) not null, bw_class varchar(250), bwlink varchar(255), bw_geolatitude float, bw_geolongitude float, status varchar(255), cost varchar(255), calendarid integer not null, dtstamp varchar(255), bw_lastmod varchar(16) not null, bw_created varchar(16) not null, priority integer, locationid integer, eventname longvarchar, bw_uid varchar(500), rfcsequence integer, transparency longvarchar, percent_complete integer, completed varchar(16), recurring char(1) not null, recurrence_id varchar(255), latest_date varchar(255), expanded char(1), schedule_method integer, originator varchar(255), organizerid integer, bw_reltype varchar(100), bw_reltoval varchar(500), schedule_state integer, primary key (eventid), unique (organizerid))
create table bw_eventsummaries (bw_eventid integer not null, bw_strid integer not null, primary key (bw_eventid, bw_strid), unique (bw_strid))
create table bw_group_Members (groupid integer not null, memberid integer not null, member_is_group char(1) not null, primary key (groupid, memberid, member_is_group))
create table bw_groups (bw_group_id integer generated by default as identity (start with 1), bwseq integer not null, bw_account longvarchar, primary key (bw_group_id))
create table bw_locations (entityid integer generated by default as identity (start with 1), bwseq integer not null, creatorid integer not null, ownerid integer not null, bwaccess longvarchar, publick char(1) not null, bw_uid varchar(50) not null, bw_locaddrid integer not null, bw_locsubaddrid integer, bwlink varchar(255), primary key (entityid), unique (bw_locaddrid), unique (bw_locsubaddrid))
create table bw_organizers (alarmid integer generated by default as identity (start with 1), bwseq integer not null, cn longvarchar, dir longvarchar, language longvarchar, sent_by longvarchar, organizer_uri longvarchar, primary key (alarmid))
create table bw_preferences (prefid integer generated by default as identity (start with 1), bwseq integer not null, ownerid integer not null, email varchar(255), default_calendarid integer, skin_name varchar(255), skin_style varchar(255), preferred_view varchar(255), preferred_view_period varchar(255), workdays varchar(255), workday_start integer, workday_end integer, preferred_endtype varchar(255), bwuser_mode integer, primary key (prefid), unique (ownerid))
create table bw_recurrences (recurrence_id varchar(255) not null, masterid integer not null, bwseq integer not null, start_date_type char(1) not null, start_tzid varchar(255), start_dtval varchar(255) not null, start_date varchar(255) not null, bw_rstart_floating char(1), end_date_type char(1), end_tzid varchar(255), end_dtval varchar(255), end_date varchar(255), bw_rend_floating char(1), overrideid integer, primary key (recurrence_id, masterid))
create table bw_rstatus (eventid integer not null, bw_rscode varchar(100), bw_rsdescid integer, bw_rsdata varchar(250), unique (bw_rsdescid))
create table bw_settings (id integer generated by default as identity (start with 1), bwseq integer not null, bwname longvarchar, tzid longvarchar, systemid longvarchar, bw_principal_root varchar(200), bw_user_principal_root varchar(200), bw_group_principal_root varchar(200), publicCalendarRoot longvarchar, userCalendarRoot longvarchar, userDefaultCalendar longvarchar, defaultTrashCalendar longvarchar, userInbox longvarchar, userOutbox longvarchar, deletedCalendar longvarchar, busyCalendar longvarchar, defaultUserViewName longvarchar, public_user longvarchar, http_connections_per_user integer, http_connections_per_host integer, http_connections integer, maxPublicDescriptionLength integer, maxUserDescriptionLength integer, maxUserEntitySize integer, defaultUserQuota bigint, bwmax_instances integer, bwmax_years integer, userauth_class longvarchar, mailer_class longvarchar, admingroups_class longvarchar, usergroups_class longvarchar, directory_browsing_disallowed char(1), bwindex_root longvarchar, primary key (id))
create table bw_strings (bw_id integer generated by default as identity (start with 1), bwseq integer not null, bw_lang varchar(100), bw_value longvarchar, primary key (bw_id))
create table bw_subscriptions (subscriptionid integer generated by default as identity (start with 1), bwseq integer not null, subscrname longvarchar not null, ownerid integer not null, uri longvarchar not null, affects_free_busy char(1) not null, ignore_transparency char(1) not null, display char(1) not null, bwsubstyle longvarchar, internal_Subscription char(1) not null, email_notifications char(1) not null, calendar_deleted char(1) not null, unremoveable char(1) not null, primary key (subscriptionid))
create table bw_synchdata (userid integer not null, eventid integer not null, bwseq integer not null, eventData longvarchar, primary key (userid, eventid))
create table bw_synchinfo (userid integer not null, deviceid varchar(255) not null, bwseq integer not null, calendarid integer, lastsynch varchar(255), primary key (userid, deviceid))
create table bw_synchstate (userid integer not null, deviceid varchar(255) not null, eventid integer not null, bwseq integer not null, guid varchar(255), state integer, primary key (userid, deviceid, eventid))
create table bw_timezones (id integer generated by default as identity (start with 1), bwseq integer not null, tzid varchar(255) not null, ownerid integer not null, publick char(1) not null, vtimezone longvarchar, jtzid varchar(255), primary key (id), unique (tzid, ownerid))
create table bw_user_properties (user_info integer not null, propname varchar(255) not null, val varchar(255), primary key (user_info, propname))
create table bw_user_subscriptions (prefid integer not null, elt integer not null, primary key (prefid, elt))
create table bw_user_views (prefid integer not null, elt integer not null, primary key (prefid, elt))
create table bw_userinfo (userid integer not null, bwseq integer not null, lastname varchar(255), firstname varchar(255), phone varchar(255), email varchar(255), department varchar(255), primary key (userid))
create table bw_users (userid integer generated by default as identity (start with 1), bwseq integer not null, username varchar(100) not null, instance_owner char(1) not null, created timestamp, last_logon timestamp, last_access timestamp, last_modify timestamp, category_access longvarchar, contact_access longvarchar, location_access longvarchar, quota bigint, primary key (userid), unique (username))
create table bw_view_subscriptions (viewid integer not null, elt integer not null, primary key (viewid, elt))
create table bw_views (viewid integer generated by default as identity (start with 1), seq integer not null, viewname longvarchar not null, ownerid integer not null, primary key (viewid))
alter table bw_adminGroupMembers add constraint FK75D9311F891E4122 foreign key (groupid) references bw_adminGroups
alter table bw_adminGroups add constraint FKFF2265197094B8E3 foreign key (ownerid) references bw_users
alter table bw_adminGroups add constraint FKFF226519FCC6CD69 foreign key (groupOwner) references bw_users
alter table bw_alarm_attendees add constraint FK8DE666A1BFB4F919 foreign key (attendeeid) references bw_attendees
alter table bw_alarm_attendees add constraint FK8DE666A16D7C4B3 foreign key (alarmid) references bw_alarms
create index valarms_user on bw_alarms (ownerid)
alter table bw_alarms add constraint FK58F4276C7094B8E3 foreign key (ownerid) references bw_users
alter table bw_alarms add constraint FK58F4276CECC95E3C foreign key (eventid) references bw_events
alter table bw_ann_alarms add constraint FK57AD568A50C58A54 foreign key (eventid) references bw_event_annotations
alter table bw_ann_alarms add constraint FK57AD568A6D7C4B3 foreign key (alarmid) references bw_alarms
alter table bw_anneventrecipients add constraint FK3CB49BBD50C58A54 foreign key (eventid) references bw_event_annotations
alter table bw_auth add constraint FK109BF7527D9DCBFB foreign key (userid) references bw_users
alter table bw_authprefCalendars add constraint FK61B6A0003D2DC521 foreign key (calendarid) references bw_calendars
alter table bw_authprefCalendars add constraint FK61B6A000808422D foreign key (userid) references bw_authprefs
alter table bw_authprefCategories add constraint FK8D77471808422D foreign key (userid) references bw_authprefs
alter table bw_authprefCategories add constraint FK8D774717E8BD8A1 foreign key (categoryid) references bw_categories
alter table bw_authprefContacts add constraint FKD32F1FE8808422D foreign key (userid) references bw_authprefs
alter table bw_authprefContacts add constraint FKD32F1FE83237EB11 foreign key (contactid) references bw_contacts
alter table bw_authprefLocations add constraint FK63DA8A69808422D foreign key (userid) references bw_authprefs
alter table bw_authprefLocations add constraint FK63DA8A69FB77CC4F foreign key (locationid) references bw_locations
alter table bw_calendar_categories add constraint FK8B8BEAD33D2DC521 foreign key (calendarid) references bw_calendars
alter table bw_calendar_categories add constraint FK8B8BEAD37E8BD8A1 foreign key (categoryid) references bw_categories
create index cal_creator on bw_calendars (creatorid)
create index cal_owner on bw_calendars (ownerid)
create index calpath on bw_calendars (bwpath)
alter table bw_calendars add constraint FK8611CD8BD321CC1C foreign key (creatorid) references bw_users
alter table bw_calendars add constraint FK8611CD8B7094B8E3 foreign key (ownerid) references bw_users
alter table bw_calendars add constraint FK8611CD8BE84B9CF2 foreign key (parent) references bw_calendars
create index idx_csrootcal on bw_calsuites (csrootcal)
create index idx_calsuite_owner on bw_calsuites (ownerid)
create index csgroup on bw_calsuites (groupid)
create index idx_calsuite_creator on bw_calsuites (creatorid)
alter table bw_calsuites add constraint FK9E5AD65F76816584 foreign key (csrootcal) references bw_calendars
alter table bw_calsuites add constraint FK9E5AD65FD321CC1C foreign key (creatorid) references bw_users
alter table bw_calsuites add constraint FK9E5AD65F891E4122 foreign key (groupid) references bw_adminGroups
alter table bw_calsuites add constraint FK9E5AD65F7094B8E3 foreign key (ownerid) references bw_users
create index idx_cat_owner on bw_categories (ownerid)
create index idx_cat_creator on bw_categories (creatorid)
alter table bw_categories add constraint FK6FE1F846D321CC1C foreign key (creatorid) references bw_users
alter table bw_categories add constraint FK6FE1F8467094B8E3 foreign key (ownerid) references bw_users
alter table bw_categories add constraint FK6FE1F846C4F486F3 foreign key (bw_catdescid) references bw_strings
alter table bw_categories add constraint FK6FE1F846B783832F foreign key (bw_catwdid) references bw_strings
create index idx_contact_creator on bw_contacts (creatorid)
create index idx_contact_owner on bw_contacts (ownerid)
alter table bw_contacts add constraint FK714294FDD321CC1C foreign key (creatorid) references bw_users
alter table bw_contacts add constraint FK714294FD7094B8E3 foreign key (ownerid) references bw_users
alter table bw_contacts add constraint FK714294FD46B4FD19 foreign key (bw_connameid) references bw_strings
alter table bw_entity_alarms add constraint FK977079B4ECC95E3C foreign key (eventid) references bw_events
alter table bw_entity_alarms add constraint FK977079B46D7C4B3 foreign key (alarmid) references bw_alarms
alter table bw_event_annotation_attendees add constraint FK83E30C984E9CEE71 foreign key (elt) references bw_attendees
alter table bw_event_annotation_attendees add constraint FK83E30C9813EADC74 foreign key (attendeeid) references bw_event_annotations
alter table bw_event_annotation_categories add constraint FKD4AC385D50C58A54 foreign key (eventid) references bw_event_annotations
alter table bw_event_annotation_categories add constraint FKD4AC385D7E8BD8A1 foreign key (categoryid) references bw_categories
create index idx_event_exdate on bw_event_annotationexdates (ex_date)
alter table bw_event_annotationexdates add constraint FKE44C2F5450C58A54 foreign key (eventid) references bw_event_annotations
create index idx_event_rdate on bw_event_annotationrdates (r_date)
alter table bw_event_annotationrdates add constraint FK6F06037150C58A54 foreign key (eventid) references bw_event_annotations
alter table bw_event_annotationrrules add constraint FK6FD445E350C58A54 foreign key (eventid) references bw_event_annotations
create index idx_eventann_end_floating on bw_event_annotations (bw_end_floating)
create index idx_eventann_calendar on bw_event_annotations (calendarid)
create index idx_eventann_location on bw_event_annotations (locationid)
create index sidx_eventann_owner on bw_event_annotations (ownerid)
create index idx_eventann_creator on bw_event_annotations (creatorid)
create index idx_eventann_deleted on bw_event_annotations (deleted)
create index idx_eventann_expanded on bw_event_annotations (expanded)
create index idx_eventann_end on bw_event_annotations (end_date)
create index idx_eventann_start on bw_event_annotations (start_date)
create index idx_eventann_latest_date on bw_event_annotations (latest_date)
create index idx_eventann_start_floating on bw_event_annotations (bw_start_floating)
create index idx_eventann_recurring on bw_event_annotations (recurring)
alter table bw_event_annotations add constraint FK3A619F95247D7B73 foreign key (targetid) references bw_events
alter table bw_event_annotations add constraint FK3A619F95D321CC1C foreign key (creatorid) references bw_users
alter table bw_event_annotations add constraint FK3A619F953D2DC521 foreign key (calendarid) references bw_calendars
alter table bw_event_annotations add constraint FK3A619F957094B8E3 foreign key (ownerid) references bw_users
alter table bw_event_annotations add constraint FK3A619F954FC14404 foreign key (masterid) references bw_events
alter table bw_event_annotations add constraint FK3A619F95EB04EBEF foreign key (organizerid) references bw_organizers
alter table bw_event_annotations add constraint FK3A619F95FB77CC4F foreign key (locationid) references bw_locations
alter table bw_event_attendees add constraint FK758457AABFB4F919 foreign key (attendeeid) references bw_attendees
alter table bw_event_attendees add constraint FK758457AAECC95E3C foreign key (eventid) references bw_events
alter table bw_event_categories add constraint FK17344F8BECC95E3C foreign key (eventid) references bw_events
alter table bw_event_categories add constraint FK17344F8B7E8BD8A1 foreign key (categoryid) references bw_categories
alter table bw_eventanncomments add constraint FK7CC49AA59DBDD23D foreign key (bw_strid) references bw_strings
alter table bw_eventanncomments add constraint FK7CC49AA54D42186A foreign key (bw_eventid) references bw_event_annotations
alter table bw_eventanncontacts add constraint FK7EDA1D0450C58A54 foreign key (eventid) references bw_event_annotations
alter table bw_eventanncontacts add constraint FK7EDA1D043237EB11 foreign key (contactid) references bw_contacts
alter table bw_eventanndescriptions add constraint FK5B27F8289DBDD23D foreign key (bw_strid) references bw_strings
alter table bw_eventanndescriptions add constraint FK5B27F8284D42186A foreign key (bw_eventid) references bw_event_annotations
alter table bw_eventannresources add constraint FKFEB797949DBDD23D foreign key (bw_strid) references bw_strings
alter table bw_eventannresources add constraint FKFEB797944D42186A foreign key (bw_eventid) references bw_event_annotations
alter table bw_eventannsummaries add constraint FKCF2600339DBDD23D foreign key (bw_strid) references bw_strings
alter table bw_eventannsummaries add constraint FKCF2600334D42186A foreign key (bw_eventid) references bw_event_annotations
alter table bw_eventcomments add constraint FK569A3C249DBDD23D foreign key (bw_strid) references bw_strings
alter table bw_eventcomments add constraint FK569A3C24E945EC52 foreign key (bw_eventid) references bw_events
alter table bw_eventcontacts add constraint FK58AFBE83ECC95E3C foreign key (eventid) references bw_events
alter table bw_eventcontacts add constraint FK58AFBE833237EB11 foreign key (contactid) references bw_contacts
alter table bw_eventdescriptions add constraint FK2642C2279DBDD23D foreign key (bw_strid) references bw_strings
alter table bw_eventdescriptions add constraint FK2642C227E945EC52 foreign key (bw_eventid) references bw_events
create index idx_event_exdate on bw_eventexdates (ex_date)
alter table bw_eventexdates add constraint FK6AEB0D82ECC95E3C foreign key (eventid) references bw_events
alter table bw_eventexrules add constraint FK6BB94FF4ECC95E3C foreign key (eventid) references bw_events
create index idx_event_rdate on bw_eventrdates (r_date)
alter table bw_eventrdates add constraint FK6B1BA783ECC95E3C foreign key (eventid) references bw_events
alter table bw_eventrecipients add constraint FKCEB063AAECC95E3C foreign key (eventid) references bw_events
alter table bw_eventresources add constraint FK5F9625F59DBDD23D foreign key (bw_strid) references bw_strings
alter table bw_eventresources add constraint FK5F9625F5E945EC52 foreign key (bw_eventid) references bw_events
alter table bw_eventrrules add constraint FK6BE9E9F5ECC95E3C foreign key (eventid) references bw_events
create index idx_event_expanded on bw_events (expanded)
create index sidx_event_owner on bw_events (ownerid)
create index eli on bw_events (locationid)
create index idx_event_calendar on bw_events (calendarid)
create index idx_event_end on bw_events (end_date)
create index idx_event_creator on bw_events (creatorid)
create index idx_event_start on bw_events (start_date)
create index idx_event_deleted on bw_events (deleted)
create index idx_event_recurring on bw_events (recurring)
create index idx_event_start_floating on bw_events (bw_start_floating)
create index idx_event_end_floating on bw_events (bw_end_floating)
create index idx_event_latest_date on bw_events (latest_date)
alter table bw_events add constraint FK60563843D321CC1C foreign key (creatorid) references bw_users
alter table bw_events add constraint FK605638433D2DC521 foreign key (calendarid) references bw_calendars
alter table bw_events add constraint FK605638437094B8E3 foreign key (ownerid) references bw_users
alter table bw_events add constraint FK60563843EB04EBEF foreign key (organizerid) references bw_organizers
alter table bw_events add constraint FK60563843FB77CC4F foreign key (locationid) references bw_locations
alter table bw_eventsummaries add constraint FK30048E949DBDD23D foreign key (bw_strid) references bw_strings
alter table bw_eventsummaries add constraint FK30048E94E945EC52 foreign key (bw_eventid) references bw_events
alter table bw_group_Members add constraint FK8EF834CF4F98698F foreign key (groupid) references bw_groups
create index location_creator on bw_locations (creatorid)
create index location_owner on bw_locations (ownerid)
alter table bw_locations add constraint FK8835B7F4D321CC1C foreign key (creatorid) references bw_users
alter table bw_locations add constraint FK8835B7F47094B8E3 foreign key (ownerid) references bw_users
alter table bw_locations add constraint FK8835B7F4212FB83D foreign key (bw_locaddrid) references bw_strings
alter table bw_locations add constraint FK8835B7F4C7170711 foreign key (bw_locsubaddrid) references bw_strings
create index prefowner on bw_preferences (ownerid)
alter table bw_preferences add constraint FKA756720E7094B8E3 foreign key (ownerid) references bw_users
alter table bw_preferences add constraint FKA756720E5C7181DF foreign key (default_calendarid) references bw_calendars
create index idx_rend_floating on bw_recurrences (bw_rend_floating)
create index idx_rstart_floating on bw_recurrences (bw_rstart_floating)
create index idx_recur_end on bw_recurrences (end_date)
create index idx_recur_start on bw_recurrences (start_date)
alter table bw_recurrences add constraint FK6BEDE594FC14404 foreign key (masterid) references bw_events
alter table bw_recurrences add constraint FK6BEDE593910AF06 foreign key (overrideid) references bw_event_annotations
alter table bw_rstatus add constraint FK55D0C0FAE30F2D32 foreign key (bw_rsdescid) references bw_strings
alter table bw_rstatus add constraint FK55D0C0FA50C58A54 foreign key (eventid) references bw_event_annotations
alter table bw_rstatus add constraint FK55D0C0FAECC95E3C foreign key (eventid) references bw_events
create index subscriptionowner on bw_subscriptions (ownerid)
alter table bw_subscriptions add constraint FK6697F08C7094B8E3 foreign key (ownerid) references bw_users
alter table bw_synchdata add constraint FKED832AED7D9DCBFB foreign key (userid) references bw_users
alter table bw_synchinfo add constraint FKED859FF17D9DCBFB foreign key (userid) references bw_users
alter table bw_synchstate add constraint FKC3BDF1AE7D9DCBFB foreign key (userid) references bw_users
alter table bw_synchstate add constraint FKC3BDF1AEECC95E3C foreign key (eventid) references bw_events
create index timezoneowner on bw_timezones (ownerid)
alter table bw_timezones add constraint FKD33B18307094B8E3 foreign key (ownerid) references bw_users
alter table bw_user_properties add constraint FK8C52523D329258C5 foreign key (user_info) references bw_userinfo
alter table bw_user_subscriptions add constraint FK2E0271AC28D230A2 foreign key (elt) references bw_subscriptions
alter table bw_user_subscriptions add constraint FK2E0271ACBCDFD720 foreign key (prefid) references bw_preferences
alter table bw_user_views add constraint FK9612D7247CFB6A2A foreign key (elt) references bw_views
alter table bw_user_views add constraint FK9612D724BCDFD720 foreign key (prefid) references bw_preferences
alter table bw_userinfo add constraint FK833CA7A37D9DCBFB foreign key (userid) references bw_users
create index idx_user_instance_owner on bw_users (instance_owner)
alter table bw_view_subscriptions add constraint FK8D3ABB0628D230A2 foreign key (elt) references bw_subscriptions
alter table bw_view_subscriptions add constraint FK8D3ABB064C4D13FD foreign key (viewid) references bw_views
create index viewowner on bw_views (ownerid)
alter table bw_views add constraint FK40536047094B8E3 foreign key (ownerid) references bw_users
